# remirepo/Fedora spec file for php-zendframework-zend-expressive-twigrenderer
#
# Copyright (c) 2016-2017 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    e48e49fb99b1598819a6f9f719d7825517295a7a
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-expressive-twigrenderer
%global php_home     %{_datadir}/php
%global library      Expressive
%global sublib       Twig
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        1.5.0
Release:        4%{?dist}
Summary:        Twig integration for %{library}

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/zend-expressive/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-composer(psr/container)                          <  2
BuildRequires:  php-composer(psr/container)                          >= 1.0
# test suite fails with v2
BuildRequires:  php-composer(twig/twig)                              <  2
BuildRequires:  php-composer(twig/twig)                              >= 1.32
BuildRequires:  php-autoloader(%{gh_owner}/zend-expressive-helpers)  >= 1.4
BuildRequires:  php-autoloader(%{gh_owner}/zend-expressive-router)   >= 1.3.2
BuildRequires:  php-autoloader(%{gh_owner}/zend-expressive-template) >= 1.0
BuildRequires:  php-pcre
BuildRequires:  php-spl
# From composer, "require-dev": {
#        "malukenho/docheader": "^0.1.5",
#        "phpunit/phpunit": "^6.0.7 || ^5.7.14",
#        "zendframework/zend-coding-standard": "~1.0.0"
%if 0%{?fedora} >= 26
%global phpunit %{_bindir}/phpunit6
%else
%global phpunit %{_bindir}/phpunit
%endif
BuildRequires:  %{phpunit}
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "container-interop/container-interop": "^1.2",
#        "twig/twig": "^1.32 || ^2.1",
#        "zendframework/zend-expressive-helpers": "^1.4 || ^2.2 || ^3.0.1 || ^4.0",
#        "zendframework/zend-expressive-router": "^1.3.2 || ^2.1",
#        "zendframework/zend-expressive-template": "^1.0.4"
Requires:       php(language) >= 5.6
Requires:       php-composer(psr/container)                          >= 1.0
Requires:       php-composer(psr/container)                          <  2
Requires:       php-composer(twig/twig)                              >= 1.32
Requires:       php-composer(twig/twig)                              <  3
Requires:       php-autoloader(%{gh_owner}/zend-expressive-helpers)  >= 1.4
Requires:       php-autoloader(%{gh_owner}/zend-expressive-helpers)  <  5
Requires:       php-autoloader(%{gh_owner}/zend-expressive-router)   >= 1.3.2
Requires:       php-autoloader(%{gh_owner}/zend-expressive-router)   <  3
Requires:       php-autoloader(%{gh_owner}/zend-expressive-template) >= 1.0.4
Requires:       php-autoloader(%{gh_owner}/zend-expressive-template) <  2
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 1.2.0
Requires:       php-pcre
Requires:       php-spl
%if ! %{bootstrap}
# From composer, "suggest": {
#        "mouf/pimple-interop": "^1.0 to use Pimple for dependency injection",
#        "aura/di": "3.0.*@beta to make use of Aura.Di dependency injection container",
#        "zendframework/zend-servicemanager": "^2.5 to use zend-servicemanager for dependency injection"
%if 0%{?fedora} >= 21
Suggests:       php-composer(aura/di)
Suggests:       php-autoloader(%{gh_owner}/zend-servicemanager)
%endif
%endif

Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}


%description
Provides Twig integration for Expressive.

Documentation: http://zend-expressive.readthedocs.io/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create dependency autoloader - deprecated
cat << 'EOF' | tee autoload.php
<?php
if (file_exists('%{php_home}/Twig/autoload.php')) {
   require_once '%{php_home}/Twig/autoload.php';
} else {
   require_once '%{php_home}/Twig2/autoload.php';
}
if (file_exists('%{php_home}/Aura/Di/autoload.php')) {
   require_once '%{php_home}/Aura/Di/autoload.php';
}
require_once '%{php_home}/Psr/Container/autoload.php';
EOF

: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Psr/Container/autoload.php',
    [
        '%{php_home}/Twig/autoload.php',
        '%{php_home}/Twig2/autoload.php',
    ],
    '%{php_home}/Zend/Expressive/Helper/autoload.php',
    '%{php_home}/Zend/Expressive/Router/autoload.php',
    '%{php_home}/Zend/Expressive/Template/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Aura/Di/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/%{library}
cp -pr src %{buildroot}%{php_home}/Zend/%{library}/%{sublib}

install -m644 autoload.php %{buildroot}%{php_home}/Zend/%{library}-%{sublib}-autoload.php


%check
%if %{with_tests}
mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/%{sublib}/autoload.php';
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\%{sublib}', dirname(__DIR__) . '/test');
EOF

ret=0
for cmdarg in "php %{phpunit}" "php56 %{_bindir}/phpunit" php70 php71 php72; do
  if which $cmdarg; then
    set $cmdarg
    $1 ${2:-%{_bindir}/phpunit6} --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}/%{sublib}/
%{php_home}/Zend/%{library}-%{sublib}-autoload.php


%changelog
* Fri Jul 13 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.0-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_29_Mass_Rebuild

* Fri Feb 09 2018 Fedora Release Engineering <releng@fedoraproject.org> - 1.5.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_28_Mass_Rebuild

* Mon Dec 11 2017 Remi Collet <remi@remirepo.net> - 1.5.0-2
- switch from zend-loader to fedora/autoloader

* Sun Aug 13 2017 Remi Collet <remi@remirepo.net> - 1.5.0-1
- Update to 1.5.0
- add dependency on psr/container
- drop dependency on container-interop/container-interop

* Thu Jul 27 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.4.0-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_27_Mass_Rebuild

* Wed Mar 15 2017 Remi Collet <remi@remirepo.net> - 1.4.0-1
- Update to 1.4.0
- use phpunit6 on F26+

* Thu Mar  2 2017 Remi Collet <remi@remirepo.net> - 1.3.0-1
- Update to 1.3.0
- allow twig 2

* Sat Feb 11 2017 Fedora Release Engineering <releng@fedoraproject.org> - 1.2.1-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_26_Mass_Rebuild

* Thu Jan 12 2017 Remi Collet <remi@fedoraproject.org> - 1.2.1-1
- update to 1.2.1 (no change)

* Thu Jan 12 2017 Remi Collet <remi@fedoraproject.org> - 1.2.0-1
- update to 1.2.0
- raise dependency on PHP version 5.6
- allow zend-expressive-helpers version 3.0
- add dependency on zend-expressive-router
- raise dependency on zend-expressive-template version 1.0.4

* Mon Jan  9 2017 Remi Collet <remi@fedoraproject.org> - 1.1.1-2
- ensure twig 1 is used (build)

* Sat Jul  2 2016 Remi Collet <remi@fedoraproject.org> - 1.1.1-1
- initial package

